// Super form ability.
// As well as Hyper, if XMomentum is present.

local experience = 0
freeslot("SFX_FILETH", "SFX_XPBMB")
sfxinfo[sfx_fileth] = {
        singular = false,
        priority = 42,
        flags = SF_NOINTERRUPT,
		caption = "Recycle Bin"
}

sfxinfo[sfx_xpbmb] = {
        singular = false,
        priority = 95,
        flags = SF_X4AWAYSOUND|SF_X8AWAYSOUND,
		caption = "XPerience Blast"
}

addHook("JumpSpinSpecial", function()
	for player in players.iterate
		if (player.mo and player.mo.valid) and player.mo.skin == "windows" and player.mo.panim != PA_ETC then
			if experience == 5*TICRATE then
				if player.hyper == nil and player.powers[pw_super] == 0 then
					return
				elseif player.powers[pw_super] != 0 then
					P_NukeEnemies(player.mo, player.mo, 2048*FRACUNIT)
					P_FlashPal(player, PAL_WHITE, 5)
					P_StartQuake(50*FRACUNIT, 5)
					experience = 0
					S_StartSound(player.mo, sfx_xpbmb)
				elseif player.hyper.capable == true and player.powers[pw_super] != 0 then
					P_NukeEnemies(player.mo, player.mo, 8192*FRACUNIT)
					P_FlashPal(player, PAL_WHITE, 10)
					P_StartQuake(98*FRACUNIT, 15)
					experience = 2*TICRATE
					S_StartSound(player.mo, sfx_xpbmb)
				end
			end
		end
	end
end)

addHook("ThinkFrame", function()
	if experience < 5*TICRATE and gamestate != 4 then
		experience = $ + 1
	elseif gamestate == 4
		experience = 0
	end
end)